package com.realnet.vpspack.Controllers;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.realnet.fnd.response.EntityResponse;
import com.realnet.vpspack.Entity.Visa_application;
import com.realnet.vpspack.Services.Visa_applicationService;

@RequestMapping(value = "/Visa_application")
@CrossOrigin("*")
@RestController
public class Visa_applicationController {
	@Autowired
	private Visa_applicationService Service;

	@Value("${projectPath}")
	private String projectPath;

	@PostMapping("/Visa_application")
	public Visa_application Savedata(@RequestBody Visa_application data) {
		Visa_application save = Service.Savedata(data);

		System.out.println("data saved..." + save);

		return save;
	}

	@PutMapping("/Visa_application/{id}")
	public Visa_application update(@RequestBody Visa_application data, @PathVariable Integer id) {
		Visa_application update = Service.update(data, id);
		System.out.println("data update..." + update);
		return update;
	}

//	get all with pagination
	@GetMapping("/Visa_application/getall/page")
	public Page<Visa_application> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Visa_application> get = Service.getAllWithPagination(paging);

		return get;

	}

	@GetMapping("/Visa_application")
	public List<Visa_application> getdetails() {
		List<Visa_application> get = Service.getdetails();
		return get;
	}
// get all without authentication 

	@GetMapping("/token/Visa_application")
	public List<Visa_application> getallwioutsec() {
		List<Visa_application> get = Service.getdetails();
		return get;
	}

	@GetMapping("/Visa_application/{id}")
	public Visa_application getdetailsbyId(@PathVariable Integer id) {
		Visa_application get = Service.getdetailsbyId(id);
		return get;
	}

	@DeleteMapping("/Visa_application/{id}")
	public ResponseEntity<?> delete_by_id(@PathVariable Integer id) {
		Service.delete_by_id(id);
		return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);

	}

}